Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Class FastHashMap

    java.lang.Object
      java.util.AbstractMap
          java.util.HashMap
              org.apache.commons.collections.FastHashMap

All Implemented Interfaces:
  Serializable, Cloneable, Map

    public class FastHashMap

extends HashMap

A customized implementation of `java.util.HashMap` designed to operate in a multithreaded environment where the large majority of method calls are read-only, instead of structural changes. When operating in "fast" mode, read calls are non-synchronized and write calls perform the following steps:

- Clone the existing collection
- Perform the modification on the clone
- Replace the existing collection with the (modified) clone

When first created, objects of this class default to "slow" mode, where all accesses of any type are synchronized but no cloning takes place. This is appropriate for initially populating the collection, followed by a switch to "fast" mode (by calling `setFast(true)`) after initialization is complete.

NOTE: If you are creating and accessing a `HashMap` only within a single thread, you should use `java.util.HashMap` directly (with no synchronization), for maximum performance.

NOTE: This class is not cross-platform. Using it may cause unexpected failures on some architectures. It suffers from the same problems as the double-checked locking idiom. In particular, the instruction that clones the internal collection and the instruction that sets the internal reference to the clone can be executed or perceived out-of-order. This means that any read operation might fail unexpectedly, as it may be reading the state of the internal collection before the internal collection is fully formed. For more information on the double-checked locking idiom, see the Double-Checked Locking Idiom Is Broken Declaration.

Since:
  Commons Collections 1.0
Version:
  $Revision: 555845 $ $Date: 2007-07-13 03:52:05 +0100 (Fri, 13 Jul 2007) $
Author:
  Craig R. McClanahan, Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class java.util.AbstractMap
`AbstractMap.SimpleEntry, AbstractMap.SimpleImmutableEntry`

Field Summary
`protected boolean` | `fast` Are we currently operating in "fast" mode?
`protected HashMap` | `map` The underlying map we are managing.

Constructor Summary
`FastHashMap()` Construct an empty map.
`FastHashMap(int capacity)` Construct an empty map with the specified capacity.
`FastHashMap(int capacity, float factor)` Construct an empty map with the specified capacity and load factor.
`FastHashMap(Map map)` Construct a new map with the same mappings as the specified map.

Method Summary
`void` | `clear()` Remove all mappings from this map.
`Object` | `clone()` Return a shallow copy of this `FastHashMap` instance.
`boolean` | `containsKey(Object key)` Return `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(Object value)` Return `true` if this map contains one or more keys mapping to the specified value.
`Set` | `entrySet()` Return a collection view of the mappings contained in this map.
`boolean` | `equals(Object o)` Compare the specified object with this list for equality.
`Object` | `get(Object key)` Return the value to which this map maps the specified key.
`boolean` | `getFast()` Returns true if this map is operating in fast mode.
`int` | `hashCode()` Return the hash code value for this map.
`boolean` | `isEmpty()` Return `true` if this map contains no mappings.
`Set` | `keySet()` Return a set view of the keys contained in this map.
`Object` | `put(Object key, Object value)` Associate the specified value with the specified key in this map.
`void` | `putAll(Map in)` Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.
`Object` | `remove(Object key)` Remove any mapping for this key, and return any previously mapped value.
`void` | `setFast(boolean fast)` Sets whether this map is operating in fast mode.
`int` | `size()` Return the number of key-value mappings in this map.
`Collection` | `values()` Return a collection view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### map

    protected HashMap map

  The underlying map we are managing.

### fast

    protected boolean fast

  Are we currently operating in "fast" mode?

Constructor Detail

### FastHashMap

    public FastHashMap()

  Construct an empty map.

### FastHashMap

    public FastHashMap(int capacity)

  Construct an empty map with the specified capacity.

  Parameters:
    `capacity` - the initial capacity of the empty map

### FastHashMap

    public FastHashMap(int capacity,
                       float factor)

  Construct an empty map with the specified capacity and load factor.

  Parameters:
    `capacity` - the initial capacity of the empty map
    `factor` - the load factor of the new map

### FastHashMap

    public FastHashMap(Map map)

  Construct a new map with the same mappings as the specified map.

  Parameters:
    `map` - the map whose mappings are to be copied

Method Detail

### getFast

    public boolean getFast()

  Returns true if this map is operating in fast mode.

  Returns:
    true if this map is operating in fast mode

### setFast

    public void setFast(boolean fast)

  Sets whether this map is operating in fast mode.

  Parameters:
    `fast` - true if this map should operate in fast mode

### get

    public Object get(Object key)

  Return the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key, or if there is a mapping with a value of `null`. Use the `containsKey()` method to disambiguate these cases.

  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `HashMap`
  Parameters:
    `key` - the key whose value is to be returned
  Returns:
    the value mapped to that key, or null

### size

    public int size()

  Return the number of key-value mappings in this map.

  Specified by:
    `size` in interface `Map`
  Overrides:
    `size` in class `HashMap`
  Returns:
    the current size of the map

### isEmpty

    public boolean isEmpty()

  Return `true` if this map contains no mappings.

  Specified by:
    `isEmpty` in interface `Map`
  Overrides:
    `isEmpty` in class `HashMap`
  Returns:
    is the map currently empty

### containsKey

    public boolean containsKey(Object key)

  Return `true` if this map contains a mapping for the specified key.

  Specified by:
    `containsKey` in interface `Map`
  Overrides:
    `containsKey` in class `HashMap`
  Parameters:
    `key` - the key to be searched for
  Returns:
    true if the map contains the key

### containsValue

    public boolean containsValue(Object value)

  Return `true` if this map contains one or more keys mapping to the specified value.

  Specified by:
    `containsValue` in interface `Map`
  Overrides:
    `containsValue` in class `HashMap`
  Parameters:
    `value` - the value to be searched for
  Returns:
    true if the map contains the value

### put

    public Object put(Object key,
                      Object value)

  Associate the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced and returned.

  Specified by:
    `put` in interface `Map`
  Overrides:
    `put` in class `HashMap`
  Parameters:
    `key` - the key with which the value is to be associated
    `value` - the value to be associated with this key
  Returns:
    the value previously mapped to the key, or null

### putAll

    public void putAll(Map in)

  Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.

  Specified by:
    `putAll` in interface `Map`
  Overrides:
    `putAll` in class `HashMap`
  Parameters:
    `in` - the map whose mappings are to be copied

### remove

    public Object remove(Object key)

  Remove any mapping for this key, and return any previously mapped value.

  Specified by:
    `remove` in interface `Map`
  Overrides:
    `remove` in class `HashMap`
  Parameters:
    `key` - the key whose mapping is to be removed
  Returns:
    the value removed, or null

### clear

    public void clear()

  Remove all mappings from this map.

  Specified by:
    `clear` in interface `Map`
  Overrides:
    `clear` in class `HashMap`

### equals

    public boolean equals(Object o)

  Compare the specified object with this list for equality. This implementation uses exactly the code that is used to define the list equals function in the documentation for the `Map.equals` method.

  Specified by:
    `equals` in interface `Map`
  Overrides:
    `equals` in class `AbstractMap`
  Parameters:
    `o` - the object to be compared to this list
  Returns:
    true if the two maps are equal

### hashCode

    public int hashCode()

  Return the hash code value for this map. This implementation uses exactly the code that is used to define the list hash function in the documentation for the `Map.hashCode` method.

  Specified by:
    `hashCode` in interface `Map`
  Overrides:
    `hashCode` in class `AbstractMap`
  Returns:
    suitable integer hash code

### clone

    public Object clone()

  Return a shallow copy of this `FastHashMap` instance. The keys and values themselves are not copied.

  Overrides:
    `clone` in class `HashMap`
  Returns:
    a clone of this map

### entrySet

    public Set entrySet()

  Return a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`.

  Specified by:
    `entrySet` in interface `Map`
  Overrides:
    `entrySet` in class `HashMap`
  Returns:
    the set of map Map entries

### keySet

    public Set keySet()

  Return a set view of the keys contained in this map.

  Specified by:
    `keySet` in interface `Map`
  Overrides:
    `keySet` in class `HashMap`
  Returns:
    the set of the Map's keys

### values

    public Collection values()

  Return a collection view of the values contained in this map.

  Specified by:
    `values` in interface `Map`
  Overrides:
    `values` in class `HashMap`
  Returns:
    the set of the Map's values

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 The Apache Software Foundation. All Rights Reserved.